import QtQuick 1.0
import com.nokia.meego 1.0

import "." as MyComponents

Page {
    
  	    
// orientationLock: PageOrientation.LockLandscape
//     orientationLock: PageOrientation.LockPortrait
    
//*******************************************************
    
    
    id: mainPage
    tools: toolbar




    property int autostartTimeout: 5
//     property int elapsed_time: 0
    
//     property string source:   "calendar"
    property string source:   "addressbook"
    property string syncMode: "two-way"
    
    property string logOutput: ""


    function setTimeout(t){
	autostartTimeout = t
    }
    
    function stop(){
	logTimer.running = false
	lStatus.text = "Stopped by user"
	logPage.setLog("Stopped by user", "black", logOutput)
	qml_to_python.terminate()
    }
    
	
	
//     anchors.margins: 0
//     anchors.margins: 10


    Item {
// 	id: col
	id: page
// 	spacing: 0
	width: parent.width  
	height: parent.height

	
	
// 	 Rectangle {
// 	    width: 480; height: 640; color: "steelblue"
// 
// 	    ListView {
// 		anchors.fill: parent; model: Qt.fontFamilies()
// 
// 		delegate: Item {
// 		    height: 40; width: ListView.view.width
// 		    Text {
// 			anchors.centerIn: parent
// 			text: modelData; font.family: modelData; font.pixelSize: 24; color: "white"
// 		    }
// 		}
// 	    }

	    
	    


	Item {
	    id: titlebar
	    width: parent.width
	    height: 70

	    Rectangle {
		anchors.fill: parent
		color: "gray";
	    }
	    
// 	    Row{
// 		spacing: 20
// 	    margins: 20
		Image {	
		    anchors {
			left: titlebar.left
			leftMargin: 10 
			verticalCenter: parent.verticalCenter
			top: parent.top
			topMargin: 10
		    }
		    id: logo
		    source: "../images/icon.png"
		    width: 50
		    height: 50
// 		    anchors.leftMargin: 5
		}
		
		Label {
		    anchors {
			left: logo.right
			leftMargin: 10 
			verticalCenter: parent.verticalCenter
			top: parent.top
			topMargin: 15
		    }
		    font.bold: true;
		    font.pixelSize: 32
		    color: "White"

		    text: "SyncEvolutionGUI"
		}
// 	    }
	}
 

	
	Flickable {	  
	    id: flickable
	    width: parent.width
	    anchors.top: titlebar.bottom
	    height: mainPage.height - titlebar.height
	    contentWidth: parent.width
	    contentHeight: col.height + 20	    
	    clip: true
	
		
	    Column { 
		id: col
		width: parent.width - 20
		spacing: 5
		
		anchors {
		    left: parent.left
		    leftMargin: 10
		    rightMargin: 10
		    topMargin: 10
		    top: parent.top
		}
			
// 		anchors.margins: 10
// 		anchors.top: titlebar.bottom
    // 	    anchors.verticalCenter: parent.verticalCenter
    // 	    height: mainPage.height - titlebar.height
// 		height: bSyncMode.height + bSources.height + bStart.height + lStatus.height + 20

		Button{
		    id: bSyncMode
		    width: parent.width
		    height: 60
		    text: syncMode
		    onClicked: {
			autoStartTimer.running = false
			dialogSyncMode.open()
// 			lStatus.text = "Select sync mode and press Start"
		    }
		} 
		
		Button{
		    id: bSources
		    width: parent.width
		    height: 60
		    text: source
		    onClicked: {
			autoStartTimer.running = false
			dialogSources.open()
// 			lStatus.text = "Select Source and Sync Mode then press Start"
		    }
		}  
		
		Button{
		    id: bStart
		    width: parent.width
		    height: 60
		    text: "Start"
		    onClicked: {
			autoStartTimer.running = false
    // 		    lStatus.visible = false
			if(text == "Start"){
// 			logText.text = ""
			    text = "Stop"
			    logTimer.running = true
			    lHint.visible = false
			    bLog.visible = true
			    lStatus.color = "black"
// 			    elapsed_time = 0
// 			    bStart.visible = false //workaround since I am not able to stap/restart the thread yet
    // 			    bSyncMode.visible = false
    // 			    bSources.visible = false
    // 			    flickable.height = parent.height - titlebar.height - buttons.height
    // 			    lStatus.text = "Select sync mode and press start"
			    logOutput = ""
			    lStatus.text = "Sync running since 0 seconds."
			    qml_to_python.start(syncMode, source)
// 			    pageStack.push(logPage)
			}
			else{ //stop
			    // text = "Start"
			    logTimer.running = false
    // 			elapsedTimeTimer.running = false
    // 			bSyncMode.enabled = true
			    bStart.text = "Start"
// 			    bStart.enabled = false //Workaround until I can exit myThread properly
// 			    bStart.visible = false 
// 			    flickable.height = parent.height - titlebar.height - buttons.height			    
			    lStatus.text = "Stopped by user"
			    logPage.setLog("Stopped by user", "black", logOutput)
			    qml_to_python.terminate()
			}
		    }
		}  
		
		Label {
		    id: lHint
		    width: parent.width
		    text: "Select Source and Sync Mode then press Start."
		}	
		
		Label {
		    id: lStatus
		    width: parent.width
		    text: "Autostart in 5 seconds."
		}
		
		Button{
		    id: bLog
		    width: parent.width
		    height: 60
		    text: "Show log"
		    visible: false
		    onClicked: {
			pageStack.push(logPage)
		    }
		}  
	    }
	    
	    /*
	    
	    Flickable {
		id: flickable
		contentWidth: logText.width
		contentHeight: logText.height
		width: parent.width  
    // 		height: parent.height - bSyncMode.height - bSources.height - bStart.height - lSyncMode.height - lSources.height - lStatus.height
    // 	    height: parent.height - bSyncMode.height - bSources.height - bStart.height - lStatus.height
		height: parent.height - titlebar.height - buttons.height
    // 	    height: parent.height  - lStatus.height
    // 	    height: 500
    // 	    flickableDirection: Flickable.VerticalFlick
		flickableDirection: Flickable.HorizontalAndVerticalFlick
		clip: true
		
		
		
		anchors.top: buttons.bottom
		
		Rectangle {
		    anchors.fill: parent
		    color: "yellow";
		}

		TextEdit{
		    id: logText
    // 		wrapMode: TextEdit.Wrap
		    width: col.width
		    readOnly:true	
    // 		font.family: "Droid Sans Mono"
    // 		font.family: "Monospace"
		    font.family: "NewCourier"
    // 		onLinkActivated:{
    // 		    console.log("link clicked")
    // 		}
			text: "******"
		    color: "blue"
		}            
	    }
	    
	    ScrollDecorator { 
		flickableItem: flickable 	  
	    }*/
	}

    }
    
    


//*******************************************************
    
    
    
    
    Timer {
	id: logTimer
	interval: 10; running: false; repeat: true
	onTriggered: {
// 	    console.log("logTimer onTriggered")
// 	    elapsed_time = elapsed_time + 1
// 	    lStatus.text = "Sync running since " + elapsed_time/10 + " seconds."
// 	    logText.text = logText.text + qml_to_python.update() + "++"
// 	    flickable.contentY = logText.height - flickable.height	    
	    if(qml_to_python.status() == false){ //done
		running = false		
		var p = logOutput.search("failed")
		var p2 = logOutput.search("ERROR")
		if(p > -1 | p > -1){ //error occured
		    lStatus.color = "red"
		    lStatus.text = "Synchronisation failed."
		    logPage.setLog("Synchronisation failed.", "red", logOutput)
		}
		else{ //ok	
		    lStatus.color = "green"
		    lStatus.text = "Synchronisation successfully completed."
		    logPage.setLog("Synchronisation successfully completed.", "green", logOutput) 
		}
		
		
		bStart.text = "Start"
// 		bStart.enabled = false //Workaround until I can exit myThread properly
// 		bStart.visible = false
		//bSyncMode.enabled = false
// 		bSyncMode.visible = false
// 		bSources.visible = false
// 		bSyncMode.enabled = true
// 		flickable.height = parent.height - titlebar.height - buttons.height
	    }
	    else{ //in progress
		logOutput = logOutput + qml_to_python.update()
		lStatus.text = "Sync running since " + qml_to_python.getRunTime() + " seconds."
		logPage.setLog("Sync running since " + qml_to_python.getRunTime() + " seconds.", "black", logOutput)
		
		
		
// 		var pEnd = logOutput.search("::::")
// 		if(p > -1){ //ended
// 		console.log("Found ::::, goint to terminate...")
// 		var p = logOutput.search("failed")
// 		var p2 = logOutput.search("ERROR")
		var p2 = logOutput.search("First ERROR encountered")
// 		if(p > -1 | p2 > -1){ //error occured
		if(p2 > -1){ //error occured
		    console.log("sync not yet stopped, but found \"failed\" string, goint to terminate...")
		    lStatus.color = "red"
		    lStatus.text = "Synchronisation failed."		    
		    logPage.setLog("Synchronisation failed.", "red", logOutput)
		    running = false
		    qml_to_python.terminate()
		    bStart.text = "Start"
// 		    bStart.enabled = false //Workaround until I can exit myThread properly  
		}
		
// // 		var p = logOutput.search(" successfully")
		var p = logOutput.search("synchronization completed successfully")
		if(p > -1){ //successfully
		    logOutput = logOutput + "+---------------+-----+-----+-----+-----+-----+-----+-----+-----+-----+" //dirty fix ;)
		    console.log("sync not yet stopped, but found \"successfully\" string, goint to terminate...")
		    lStatus.color = "green"
		    lStatus.text = "Synchronisation successfully completed."
		    logPage.setLog("Synchronisation successfully completed.", "green", logOutput) 
		    running = false
		    qml_to_python.terminate()
		    bStart.text = "Start"
// 		    bStart.enabled = false //Workaround until I can exit myThread properly  
		}
// 		}
	    }
	}
     }

//*******************************************************
    
    
    
    
    Timer {
	id: autoStartTimer
// 	interval: 1000; running: false; repeat: true
	interval: 1000; running: true; repeat: true
	onTriggered: {
	    autostartTimeout = autostartTimeout - 1
	    lStatus.text = "Autostart in " + autostartTimeout + " seconds."
	    if(autostartTimeout == 0){	 
		bStart.text = "Stop"
		lStatus.color = "black"
		bLog.visible = true
		lHint.visible = false
// 		bSyncMode.visible = false
// 		bSources.visible = false
		autoStartTimer.running = false
		logTimer.running = true
  // 	      lStatus.visible = false
// 		elapsed_time = 0
  // 	      elapsedTimeTimer.running = true
		lStatus.text = "Sync running since 0 seconds."
		logOutput = ""
// 		flickable.height = parent.height - titlebar.height - buttons.height
		qml_to_python.start(syncMode, source)
// 		pageStack.push(logPage)
	    }
	}
     }


    


//*******************************************************
 
 
 
 

    SelectionDialog {
        id: dialogSyncMode
        titleText: "Select sync mode"

        model: ListModel {
	    id: syncModeList
	    ListElement { name: "two-way" }
	    ListElement { name: "slow" }
	    ListElement { name: "refresh-from-client" }
	    ListElement { name: "refresh-from-server" }
	    ListElement { name: "one-way-from-client" }
	    ListElement { name: "one-way-from-server" }
	}

        onAccepted: { 
		syncMode = dialogSyncMode.model.get(dialogSyncMode.selectedIndex).name
		bSyncMode.text = syncMode
// 		qml_to_python.setSyncMode(syncMode)
	}
    } 

//*******************************************************
 
 
 
 

    SelectionDialog {
        id: dialogSources
        titleText: "Select sources"

        model: ListModel {
	    id: sourcesList
	    ListElement { name: "calendar"; value: "calendar" }
	    ListElement { name: "addressbook"; value: "addressbook"}
	    ListElement { name: "calendar + addressbook"; value: "calendar addressbook" }
	    ListElement { name: "memos"; value: "memo" }
	    ListElement { name: "todo"; value: "todo" }
	    ListElement { name: "all"; value: "calendar addressbook memo todo" }
	}

        onAccepted: { 
		source = dialogSources.model.get(dialogSources.selectedIndex).value
		bSources.text = dialogSources.model.get(dialogSources.selectedIndex).name
	}
    } 

//*******************************************************







    ToolBarLayout {
	id: toolbar
	
	ToolButtonRow {          
	} //needed, so the menu is on the right side	      
	    
	ToolIcon {
	    iconId: "toolbar-view-menu" ;
// 	    text: "About Syncevolution"
	    onClicked: myMenu.open();
	}
    } 



//*******************************************************


    MyComponents.LogPage {
        id: logPage
    }

    
    
}
